---
title: Token (CIBA)
description: The relying party (RP) uses the POST /{{envID}}/as/token endpoint to obtain an access token after successfully being granted authorization by the CIBA authorization endpoint.
component: pingone-api
page_id: pingone-api:auth:openid-connect-oauth-2/token-ciba
canonical_url: https://developer.pingidentity.com/pingone-api/auth/openid-connect-oauth-2/token-ciba.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Token (CIBA)

##

```none
POST {{authPath}}/{{envID}}/as/token
```

The relying party (RP) uses the `POST /{{envID}}/as/token` endpoint to obtain an access token after successfully being granted authorization by the CIBA authorization endpoint.

You must include the `auth_req_id` and `grant_type` properties in the body of the request. The `auth_req_id` value is returned by the CIBA authorization endpoint in the previous step.

When using the poll token delivery method, the application polls this endpoint until it receives a success response or an error response indicating a terminal state (an error value other than `authorization_pending` or `slow_down`).

The application's configured `tokenEndpointAuthMethod` value determines how you authenticate. This must be either `CLIENT_SECRET_BASIC`, `CLIENT_SECRET_JWT`, `PRIVATE_KEY_JWT`, or `CLIENT_SECRET_POST`.

In the sample request shown here, the application's `tokenEndpointAuthMethod` value is `CLIENT_SECRET_BASIC`, which requires the `Authorization: Basic` HTTP header and a Base64-encoded representation of "username:password" in the request, in which the username is the `client_id` and the password is the `client_secret`.

If the application's `tokenEndpointAuthMethod` value is `CLIENT_SECRET_JWT`, the endpoint accepts a JWT signed by the application's client secret to authenticate the request. For information about creating the JWT and the claims in the JWT, refer to [Create a client secret JWT](../auth-config-options/create-a-client-secret-jwt.html). This request requires the `client_assertion` and `client_assertion_type` properties to specify the JWT:

```
curl --location --request POST '{{authPath}}/{{envID}}/as/token' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--data-urlencode 'client_assertion={{clientSecretJWT}}' \
--data-urlencode 'client_assertion_type=urn:ietf:params:oauth:client-assertion-type:jwt-bearer' \
--data-urlencode 'auth_req_id={{cibaAuthID}}' \
--data-urlencode 'grant_type=urn:openid:params:grant-type:ciba'
```

If the application's `tokenEndpointAuthMethod` value is `PRIVATE_KEY_JWT`, the endpoint accepts a JWT signed by an external private key file to authenticate the request. Learn more about creating the JWT and the claims in the JWT in [Create a private key JWT](../auth-config-options/create-a-private-key-jwt.html). This request requires the `client_assertion` and `client_assertion_type` properties to specify the JWT:

```
curl --location --request POST '{{authPath}}/{{envID}}/as/token' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--data-urlencode 'client_assertion={{privateKeyJWT}}' \
--data-urlencode 'client_assertion_type=urn:ietf:params:oauth:client-assertion-type:jwt-bearer' \
--data-urlencode 'auth_req_id={{cibaAuthID}}' \
--data-urlencode 'grant_type=urn:openid:params:grant-type:ciba'
```

If the application's `tokenEndpointAuthMethod` value is `CLIENT_SECRET_POST`, the request does not require an Authorization header, and the `client_id` and `client_secret` properties are sent in the request body:

```
curl --location --request POST '{{authPath}}/{{envID}}/as/token' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--data-urlencode 'client_id={{appID}}' \
--data-urlencode 'client_secret={{appSecret}}'\
--data-urlencode 'auth_req_id={{cibaAuthID}}' \
--data-urlencode 'grant_type=urn:openid:params:grant-type:ciba'
```

> **Collapse: Related topics**
>
> * [Access tokens and ID tokens](../../foundations/authentication-concepts/access-tokens-and-id-tokens.html)
>
> * [Token claims](../../foundations/authentication-concepts/access-tokens-and-id-tokens/token-claims.html)

### Prerequisites

* Refer to [OpenID Connect/OAuth 2](../openid-connect-oauth-2.html), [Token](token-intro.html), and [CIBA grant type](../../foundations/authentication-concepts/authorization-flow-by-grant-type/ciba-grant-type.html) for overview information.

* Run [CIBA Authorize](authorize-ciba.html) to obtain an `auth_req_id` value.

> **Collapse: Request Model**
>
> | Property      | Type   | Required? |
> | ------------- | ------ | --------- |
> | `auth_req_id` | String | Required  |
> | `grant_type`  | String | Required  |
>
> Refer to the [OpenID Connect/OAuth2 data model](../openid-connect-oauth-2.html) for full property descriptions.

### Headers

Authorization

Content-Type      application/x-www-form-urlencoded

### Body

urlencoded ( application/x-www-form-urlencoded )

| Key           | Value                             |
| ------------- | --------------------------------- |
| grant\_type   | urn:openid:params:grant-type:ciba |
| auth\_req\_id | {{cibaAuthID}}                    |

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{authPath}}/{{envID}}/as/token' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--header 'Authorization: Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0=' \
--data-urlencode 'grant_type=urn:openid:params:grant-type:ciba' \
--data-urlencode 'auth_req_id={{cibaAuthID}}'
```

```csharp
var options = new RestClientOptions("{{authPath}}/{{envID}}/as/token")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/x-www-form-urlencoded");
request.AddHeader("Authorization", "Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0=");
request.AddParameter("grant_type", "urn:openid:params:grant-type:ciba");
request.AddParameter("auth_req_id", "{{cibaAuthID}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{authPath}}/{{envID}}/as/token"
  method := "POST"

  payload := strings.NewReader("grant_type=urn%3Aopenid%3Aparams%3Agrant-type%3Aciba&auth_req_id=%7B%7BcibaAuthID%7D%7D")

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/x-www-form-urlencoded")
  req.Header.Add("Authorization", "Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0=")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /{{envID}}/as/token HTTP/1.1
Host: {{authPath}}
Content-Type: application/x-www-form-urlencoded
Authorization: Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0=

grant_type=urn%3Aopenid%3Aparams%3Agrant-type%3Aciba&auth_req_id=%7B%7BcibaAuthID%7D%7D
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
RequestBody body = RequestBody.create(mediaType, "grant_type=urn:openid:params:grant-type:ciba&auth_req_id={{cibaAuthID}}");
Request request = new Request.Builder()
  .url("{{authPath}}/{{envID}}/as/token")
  .method("POST", body)
  .addHeader("Content-Type", "application/x-www-form-urlencoded")
  .addHeader("Authorization", "Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0=")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{authPath}}/{{envID}}/as/token",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/x-www-form-urlencoded",
    "Authorization": "Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0="
  },
  "data": {
    "grant_type": "urn:openid:params:grant-type:ciba",
    "auth_req_id": "{{cibaAuthID}}"
  }
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{authPath}}/{{envID}}/as/token',
  'headers': {
    'Content-Type': 'application/x-www-form-urlencoded',
    'Authorization': 'Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0='
  },
  form: {
    'grant_type': 'urn:openid:params:grant-type:ciba',
    'auth_req_id': '{{cibaAuthID}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{authPath}}/{{envID}}/as/token"

payload = 'grant_type=urn%3Aopenid%3Aparams%3Agrant-type%3Aciba&auth_req_id=%7B%7BcibaAuthID%7D%7D'
headers = {
  'Content-Type': 'application/x-www-form-urlencoded',
  'Authorization': 'Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0='
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/as/token');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/x-www-form-urlencoded',
  'Authorization' => 'Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0='
));
$request->addPostParameter(array(
  'grant_type' => 'urn:openid:params:grant-type:ciba',
  'auth_req_id' => '{{cibaAuthID}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{authPath}}/{{envID}}/as/token")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/x-www-form-urlencoded"
request["Authorization"] = "Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0="
request.body = "grant_type=urn%3Aopenid%3Aparams%3Agrant-type%3Aciba&auth_req_id=%7B%7BcibaAuthID%7D%7D"

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "grant_type=urn%3Aopenid%3Aparams%3Agrant-type%3Aciba&auth_req_id=%7B%7BcibaAuthID%7D%7D"
let postData =  parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/as/token")!,timeoutInterval: Double.infinity)
request.addValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
request.addValue("Basic e3thcHBJRH19Ont7YXBwU2VjcmV0fX0=", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "access_token": "eyJhbGciOiJSUz...",
    "token_type": "Bearer",
    "expires_in": 3600,
    "scope": "exampleScope"
 }
```
